#ifndef Perceptron_HPP
#define Perceptron_HPP

#include <cmath>
#include <iostream>
using namespace std;

class perceptron {
  double * W;
  double b;
  int size;
  double (*activation)(double);
  double (*d_activation)(double);
public:
  perceptron (){
    W=nullptr;
    b=0;
    size=0;
    activation= nullptr;
    d_activation= nullptr;

  }
  perceptron (int n, double (*act)(double), double (*d_act)(double)){
    W= new double[n];
    b=0;
    size=n;
    activation= act;
    d_activation= d_act;

  }
  perceptron (const perceptron & x){
    size=x.size;
    b=x.b;
    activation=x.activation;
    if (x.W!=nullptr){
      W= new double[size];
      for(int i=0;i<size;i++){
        W[i]=x.W[i];
      } 
    }
  }
  ~perceptron(){
    if(W != nullptr){
      delete [] W;
    }
  }
  void set_W(int,double);
  void set_b(double);
  double get_W(int);
  double get_b();
  double apply_act(double);
  double apply_dact(double);
  perceptron & operator = (const perceptron &);

};

perceptron & perceptron::operator = (const perceptron & x){
  if(&x != this){
    size=x.size;
    b=x.b;
    activation=x.activation;
    if(W!=nullptr){
      delete [] W;
    }
    if (x.W!=nullptr){
      W= new double[size];
      for(int i=0;i<size;i++){
        W[i]=x.W[i];
      } 
    }
  }
  return *this;
}

  void perceptron::set_W(int i,double x){
    W[i]=x;
  }
  void perceptron::set_b(double x){
    b=x;
  }
  double perceptron::get_W(int i){
    return W[i];
  }
  double perceptron::get_b(){
    return b;
  }

  double perceptron::apply_act(double x){
    double y=this->activation(x);
    return y;
  }
  double perceptron::d_apply_dact(double x ){
    double y=this->d_activation(x);
    return y;
  }

#endif
